--- vcl.orig/unx/gtk/gdi/salnativewidgets-gtk.cxx	2010-06-21 12:34:41.000000000 +0100
+++ vcl/unx/gtk/gdi/salnativewidgets-gtk.cxx	2010-06-21 13:19:37.000000000 +0100
@@ -2765,19 +2858,19 @@
     if( nPart == PART_MENU_ITEM && ! (nState & CTRL_STATE_ENABLED) )
         return FALSE;
     
-	GtkStateType	stateType;
-	GtkShadowType	shadowType;
+    GtkStateType    stateType;
+    GtkShadowType   shadowType;
     GtkShadowType   selected_shadow_type = GTK_SHADOW_OUT;
-	gint			x, y, w, h;
-    GdkRectangle	clipRect;
+    gint            x, y, w, h;
+    GdkRectangle    clipRect;
     
-	NWEnsureGTKMenu( m_nScreen );
-	NWConvertVCLStateToGTKState( nState, &stateType, &shadowType );
+    NWEnsureGTKMenu( m_nScreen );
+    NWConvertVCLStateToGTKState( nState, &stateType, &shadowType );
     
-	x = rControlRectangle.Left();
+    x = rControlRectangle.Left();
     y = rControlRectangle.Top();
-	w = rControlRectangle.GetWidth();
-	h = rControlRectangle.GetHeight();
+    w = rControlRectangle.GetWidth();
+    h = rControlRectangle.GetHeight();
 
     if( nPart == PART_MENU_ITEM &&
         ( nState & (CTRL_STATE_SELECTED|CTRL_STATE_ROLLOVER) ) )
@@ -2879,26 +2972,26 @@
         }
     }
     
-	return( TRUE );
+    return( TRUE );
 }
 
 BOOL GtkSalGraphics::NWPaintGTKTooltip(
             GdkDrawable* gdkDrawable,
             ControlType, ControlPart,
-			const Rectangle& rControlRectangle,
+            const Rectangle& rControlRectangle,
             const clipList& rClipList,
             ControlState, const ImplControlValue&,
 			const OUString& )
 {
     NWEnsureGTKTooltip( m_nScreen );
     
-	gint			x, y, w, h;
-    GdkRectangle	clipRect;
+    gint            x, y, w, h;
+    GdkRectangle    clipRect;
     
-	x = rControlRectangle.Left();
+    x = rControlRectangle.Left();
     y = rControlRectangle.Top();
-	w = rControlRectangle.GetWidth();
-	h = rControlRectangle.GetHeight();
+    w = rControlRectangle.GetWidth();
+    h = rControlRectangle.GetHeight();
 
     for( clipList::const_iterator it = rClipList.begin(); it != rClipList.end(); ++it )
     {
@@ -2917,13 +3010,13 @@
                             x, y, w, h );
     }
     
-	return( TRUE );
+    return( TRUE );
 }
 
 BOOL GtkSalGraphics::NWPaintGTKListNode(
             GdkDrawable*,
             ControlType, ControlPart,
-			const Rectangle& rControlRectangle,
+            const Rectangle& rControlRectangle,
             const clipList&,
             ControlState nState, const ImplControlValue& rValue,
 			const OUString& )
@@ -2935,13 +3028,13 @@
     aRect.Right() += 2;
     aRect.Top() -= 2;
     aRect.Bottom() += 2;
-	gint			w, h;
-	w = aRect.GetWidth();
-	h = aRect.GetHeight();
-
-	GtkStateType	stateType;
-	GtkShadowType	shadowType;
-	NWConvertVCLStateToGTKState( nState, &stateType, &shadowType );
+    gint            w, h;
+    w = aRect.GetWidth();
+    h = aRect.GetHeight();
+
+    GtkStateType    stateType;
+    GtkShadowType   shadowType;
+    NWConvertVCLStateToGTKState( nState, &stateType, &shadowType );
 
     ButtonValue aButtonValue = rValue.getTristateVal();
     GtkExpanderStyle eStyle = GTK_EXPANDER_EXPANDED;
@@ -2968,25 +3061,25 @@
                         w/2, h/2,
                         eStyle );
 
-	BOOL bRet = NWRenderPixmapToScreen( pixmap, aRect );
+    BOOL bRet = NWRenderPixmapToScreen( pixmap, aRect );
     g_object_unref( pixmap );
 
-	return bRet;
+    return bRet;
 }
 
 BOOL GtkSalGraphics::NWPaintGTKProgress(
             GdkDrawable*,
             ControlType, ControlPart,
-			const Rectangle& rControlRectangle,
+            const Rectangle& rControlRectangle,
             const clipList&,
             ControlState, const ImplControlValue& rValue,
 			const OUString& )
 {
     NWEnsureGTKProgressBar( m_nScreen );
     
-	gint			w, h;
-	w = rControlRectangle.GetWidth();
-	h = rControlRectangle.GetHeight();
+    gint            w, h;
+    w = rControlRectangle.GetWidth();
+    h = rControlRectangle.GetHeight();
 
     long nProgressWidth = rValue.getNumericVal();
     
@@ -3158,120 +3251,10 @@
     }
     #endif
 
-	BOOL bRet = NWRenderPixmapToScreen( pixmap, rControlRectangle );
+    BOOL bRet = NWRenderPixmapToScreen( pixmap, rControlRectangle );
     g_object_unref( pixmap );
 
-	return bRet;
-}
-
-//----
-
-static Rectangle NWGetListBoxButtonRect( int nScreen,
-                                         ControlType,
-                                         ControlPart    nPart,
-                                         Rectangle      aAreaRect,
-                                         ControlState,
-                                         const ImplControlValue&,
-                                         const OUString& )
-{
-	Rectangle       aPartRect;
-	GtkRequisition *pIndicatorSize = NULL;
-	GtkBorder      *pIndicatorSpacing = NULL;
-	gint            width = 13;	// GTK+ default
-	gint            right = 5;	// GTK+ default
-	gint            nButtonAreaWidth = 0;
-    gint            xthickness = 0;
-
-	NWEnsureGTKOptionMenu( nScreen );
-
-	gtk_widget_style_get( gWidgetData[nScreen].gOptionMenuWidget,
-			"indicator_size",	&pIndicatorSize,
-			"indicator_spacing",&pIndicatorSpacing, (char *)NULL);
-	
-	if ( pIndicatorSize )
-		width = pIndicatorSize->width;
-
-	if ( pIndicatorSpacing )
-		right = pIndicatorSpacing->right;
-
-    Size aPartSize( 0, aAreaRect.GetHeight() );
-    Point aPartPos ( 0, aAreaRect.Top() );
-
-    xthickness = gWidgetData[nScreen].gOptionMenuWidget->style->xthickness;
-	nButtonAreaWidth = width + right + (xthickness * 2);
-	switch( nPart )
-	{
-		case PART_BUTTON_DOWN:
-			aPartSize.Width() = nButtonAreaWidth;
-			aPartPos.X() = aAreaRect.Left() + aAreaRect.GetWidth() - aPartSize.Width();
-			break;
-
-		case PART_SUB_EDIT:
-			aPartSize.Width() = aAreaRect.GetWidth() - nButtonAreaWidth - xthickness;
-			aPartPos.X() = aAreaRect.Left() + xthickness;
-			break;
-
-		default:
-			aPartSize.Width() = aAreaRect.GetWidth();	
-			aPartPos.X() = aAreaRect.Left();
-			break;
-	}
-    aPartRect = Rectangle( aPartPos, aPartSize );
-
-	if ( pIndicatorSize )
-		gtk_requisition_free( pIndicatorSize );
-	if ( pIndicatorSpacing )
-		gtk_border_free( pIndicatorSpacing );
-
-	return( aPartRect );
-}
-
-//----
-
-static Rectangle NWGetListBoxIndicatorRect( int nScreen,
-                                            ControlType,
-                                            ControlPart,
-                                            Rectangle				aAreaRect,
-                                            ControlState,
-                                            const ImplControlValue&,
-                                            const OUString& )
-{
-	Rectangle       aIndicatorRect;
-	GtkRequisition *pIndicatorSize = NULL;
-	GtkBorder      *pIndicatorSpacing = NULL;
-	gint            width = 13;	// GTK+ default
-	gint            height = 13;	// GTK+ default
-	gint            right = 5;	// GTK+ default
-
-	NWEnsureGTKOptionMenu( nScreen );
-
-	gtk_widget_style_get( gWidgetData[nScreen].gOptionMenuWidget,
-			"indicator_size",	&pIndicatorSize,
-			"indicator_spacing",&pIndicatorSpacing, (char *)NULL);
-	
-	if ( pIndicatorSize )
-    {
-		width = pIndicatorSize->width;
-		height = pIndicatorSize->height;
-    }
-
-	if ( pIndicatorSpacing )
-		right = pIndicatorSpacing->right;
-
-    aIndicatorRect.SetSize( Size( width, height ) );
-	aIndicatorRect.SetPos( Point( aAreaRect.Left() + aAreaRect.GetWidth() - width - right - gWidgetData[nScreen].gOptionMenuWidget->style->xthickness,
-                                  aAreaRect.Top() + ((aAreaRect.GetHeight() - height) / 2) ) );
-
-	// If height is odd, move the indicator down 1 pixel
-	if ( aIndicatorRect.GetHeight() % 2 )
-		aIndicatorRect.Move( 0, 1 );
-
-	if ( pIndicatorSize )
-		gtk_requisition_free( pIndicatorSize );
-	if ( pIndicatorSpacing )
-		gtk_border_free( pIndicatorSpacing );
-
-	return( aIndicatorRect );
+    return bRet;
 }
 
 static Rectangle NWGetToolbarRect(  int nScreen,
@@ -3477,7 +3460,7 @@
     // make the "light" color lighter than the menu color and the "shadow"
     // color darker than it.
     if ( aStyleSet.GetMenuColor().GetLuminance() >= 32 &&
-	 aStyleSet.GetMenuColor().GetLuminance() <= aStyleSet.GetMenuTextColor().GetLuminance() )
+     aStyleSet.GetMenuColor().GetLuminance() <= aStyleSet.GetMenuTextColor().GetLuminance() )
     {
       Color temp = aStyleSet.GetMenuColor();
       temp.IncreaseLuminance( 8 );
@@ -3495,10 +3478,10 @@
     aStyleSet.SetMenuHighlightTextColor( aHighlightTextColor );
     
     // UI font
-    OString	aFamily		= pango_font_description_get_family( pStyle->font_desc );
-    int nPangoHeight	= pango_font_description_get_size( pStyle->font_desc );
-    PangoStyle	eStyle	= pango_font_description_get_style( pStyle->font_desc );
-    PangoWeight	eWeight	= pango_font_description_get_weight( pStyle->font_desc );
+    OString aFamily     = pango_font_description_get_family( pStyle->font_desc );
+    int nPangoHeight    = pango_font_description_get_size( pStyle->font_desc );
+    PangoStyle  eStyle  = pango_font_description_get_style( pStyle->font_desc );
+    PangoWeight eWeight = pango_font_description_get_weight( pStyle->font_desc );
     PangoStretch eStretch = pango_font_description_get_stretch( pStyle->font_desc );
     
     psp::FastPrintFontInfo aInfo;
@@ -3507,9 +3490,9 @@
     // set italic
     switch( eStyle )
     {
-        case PANGO_STYLE_NORMAL:	aInfo.m_eItalic = psp::italic::Upright;break;
-        case PANGO_STYLE_ITALIC:	aInfo.m_eItalic = psp::italic::Italic;break;
-        case PANGO_STYLE_OBLIQUE:	aInfo.m_eItalic = psp::italic::Oblique;break;
+        case PANGO_STYLE_NORMAL:    aInfo.m_eItalic = psp::italic::Upright;break;
+        case PANGO_STYLE_ITALIC:    aInfo.m_eItalic = psp::italic::Italic;break;
+        case PANGO_STYLE_OBLIQUE:   aInfo.m_eItalic = psp::italic::Oblique;break;
     }
     // set weight
     if( eWeight <= PANGO_WEIGHT_ULTRALIGHT )
@@ -3525,15 +3508,15 @@
     // set width
     switch( eStretch )
     {
-        case PANGO_STRETCH_ULTRA_CONDENSED:	aInfo.m_eWidth = psp::width::UltraCondensed;break;
-        case PANGO_STRETCH_EXTRA_CONDENSED:	aInfo.m_eWidth = psp::width::ExtraCondensed;break;
-        case PANGO_STRETCH_CONDENSED:		aInfo.m_eWidth = psp::width::Condensed;break;
-        case PANGO_STRETCH_SEMI_CONDENSED:	aInfo.m_eWidth = psp::width::SemiCondensed;break;
-        case PANGO_STRETCH_NORMAL:			aInfo.m_eWidth = psp::width::Normal;break;
-        case PANGO_STRETCH_SEMI_EXPANDED:	aInfo.m_eWidth = psp::width::SemiExpanded;break;
-        case PANGO_STRETCH_EXPANDED:		aInfo.m_eWidth = psp::width::Expanded;break;
-        case PANGO_STRETCH_EXTRA_EXPANDED:	aInfo.m_eWidth = psp::width::ExtraExpanded;break;
-        case PANGO_STRETCH_ULTRA_EXPANDED:	aInfo.m_eWidth = psp::width::UltraExpanded;break;
+        case PANGO_STRETCH_ULTRA_CONDENSED: aInfo.m_eWidth = psp::width::UltraCondensed;break;
+        case PANGO_STRETCH_EXTRA_CONDENSED: aInfo.m_eWidth = psp::width::ExtraCondensed;break;
+        case PANGO_STRETCH_CONDENSED:       aInfo.m_eWidth = psp::width::Condensed;break;
+        case PANGO_STRETCH_SEMI_CONDENSED:  aInfo.m_eWidth = psp::width::SemiCondensed;break;
+        case PANGO_STRETCH_NORMAL:          aInfo.m_eWidth = psp::width::Normal;break;
+        case PANGO_STRETCH_SEMI_EXPANDED:   aInfo.m_eWidth = psp::width::SemiExpanded;break;
+        case PANGO_STRETCH_EXPANDED:        aInfo.m_eWidth = psp::width::Expanded;break;
+        case PANGO_STRETCH_EXTRA_EXPANDED:  aInfo.m_eWidth = psp::width::ExtraExpanded;break;
+        case PANGO_STRETCH_ULTRA_EXPANDED:  aInfo.m_eWidth = psp::width::UltraExpanded;break;
     }
 
 #if OSL_DEBUG_LEVEL > 1
@@ -3627,18 +3610,18 @@
     g_free( pIconThemeName );
 
     //  FIXME: need some way of fetching toolbar icon size.
-//	aStyleSet.SetToolbarIconSize( STYLE_TOOLBAR_ICONSIZE_SMALL );
+//  aStyleSet.SetToolbarIconSize( STYLE_TOOLBAR_ICONSIZE_SMALL );
 
     const cairo_font_options_t* pNewOptions = NULL;
     if( GdkScreen* pScreen = gdk_display_get_screen( gdk_display_get_default(), m_nScreen ) )
     {
 //#if !GTK_CHECK_VERSION(2,8,1)
 #if !GTK_CHECK_VERSION(2,9,0)
-	static cairo_font_options_t* (*gdk_screen_get_font_options)(GdkScreen*) = 
-		(cairo_font_options_t*(*)(GdkScreen*))osl_getAsciiFunctionSymbol( GetSalData()->m_pPlugin, "gdk_screen_get_font_options" );
+    static cairo_font_options_t* (*gdk_screen_get_font_options)(GdkScreen*) = 
+        (cairo_font_options_t*(*)(GdkScreen*))osl_getAsciiFunctionSymbol( GetSalData()->m_pPlugin, "gdk_screen_get_font_options" );
     if( gdk_screen_get_font_options != NULL )
 #endif
-		pNewOptions = gdk_screen_get_font_options( pScreen );
+        pNewOptions = gdk_screen_get_font_options( pScreen );
     }
     aStyleSet.SetCairoFontOptions( pNewOptions );
 
@@ -3698,8 +3681,8 @@
 GdkPixmap* GtkSalGraphics::NWGetPixmapFromScreen( Rectangle srcRect )
 {
     // Create a new pixmap to hold the composite of the window background and the control
-    GdkPixmap * pPixmap		= gdk_pixmap_new( GDK_DRAWABLE(GetGdkWindow()), srcRect.GetWidth(), srcRect.GetHeight(), -1 ); 
-	GdkGC *	 pPixmapGC	= gdk_gc_new( pPixmap );
+    GdkPixmap * pPixmap     = gdk_pixmap_new( GDK_DRAWABLE(GetGdkWindow()), srcRect.GetWidth(), srcRect.GetHeight(), -1 ); 
+    GdkGC *  pPixmapGC  = gdk_gc_new( pPixmap );
 
     if( !pPixmap || !pPixmapGC )
     {
@@ -3760,29 +3743,29 @@
  * State conversion
  ************************************************************************/
 static void NWConvertVCLStateToGTKState( ControlState nVCLState,
-			GtkStateType* nGTKState, GtkShadowType* nGTKShadow )
+            GtkStateType* nGTKState, GtkShadowType* nGTKShadow )
 {
-	*nGTKShadow = GTK_SHADOW_OUT;
-	*nGTKState = GTK_STATE_INSENSITIVE;
+    *nGTKShadow = GTK_SHADOW_OUT;
+    *nGTKState = GTK_STATE_INSENSITIVE;
 
-	if ( nVCLState & CTRL_STATE_ENABLED )
-	{
-		if ( nVCLState & CTRL_STATE_PRESSED )
-		{
-			*nGTKState = GTK_STATE_ACTIVE;
-			*nGTKShadow = GTK_SHADOW_IN;
-		}
-		else if ( nVCLState & CTRL_STATE_ROLLOVER )
-		{
-			*nGTKState = GTK_STATE_PRELIGHT;
-			*nGTKShadow = GTK_SHADOW_OUT;
-		}
-		else
-		{
-			*nGTKState = GTK_STATE_NORMAL;
-			*nGTKShadow = GTK_SHADOW_OUT;
-		}
-	}
+    if ( nVCLState & CTRL_STATE_ENABLED )
+    {
+        if ( nVCLState & CTRL_STATE_PRESSED )
+        {
+            *nGTKState = GTK_STATE_ACTIVE;
+            *nGTKShadow = GTK_SHADOW_IN;
+        }
+        else if ( nVCLState & CTRL_STATE_ROLLOVER )
+        {
+            *nGTKState = GTK_STATE_PRELIGHT;
+            *nGTKShadow = GTK_SHADOW_OUT;
+        }
+        else
+        {
+            *nGTKState = GTK_STATE_NORMAL;
+            *nGTKShadow = GTK_SHADOW_OUT;
+        }
+    }
 }
 
 /************************************************************************
@@ -3790,19 +3773,19 @@
  ************************************************************************/
 static void NWSetWidgetState( GtkWidget* widget, ControlState nState, GtkStateType nGtkState )
 {
-	// Set to default state, then build up from there
-	GTK_WIDGET_UNSET_FLAGS( widget, GTK_HAS_DEFAULT );
-	GTK_WIDGET_UNSET_FLAGS( widget, GTK_HAS_FOCUS );
-	GTK_WIDGET_UNSET_FLAGS( widget, GTK_SENSITIVE );
-	GTK_WIDGET_SET_FLAGS( widget, gWidgetDefaultFlags[(long)widget] );
-
-	if ( nState & CTRL_STATE_DEFAULT )
-		GTK_WIDGET_SET_FLAGS( widget, GTK_HAS_DEFAULT );
-	if ( !GTK_IS_TOGGLE_BUTTON(widget) && (nState & CTRL_STATE_FOCUSED) )
-		GTK_WIDGET_SET_FLAGS( widget, GTK_HAS_FOCUS );
-	if ( nState & CTRL_STATE_ENABLED )
-		GTK_WIDGET_SET_FLAGS( widget, GTK_SENSITIVE );
-	gtk_widget_set_state( widget, nGtkState );
+    // Set to default state, then build up from there
+    GTK_WIDGET_UNSET_FLAGS( widget, GTK_HAS_DEFAULT );
+    GTK_WIDGET_UNSET_FLAGS( widget, GTK_HAS_FOCUS );
+    GTK_WIDGET_UNSET_FLAGS( widget, GTK_SENSITIVE );
+    GTK_WIDGET_SET_FLAGS( widget, gWidgetDefaultFlags[(long)widget] );
+
+    if ( nState & CTRL_STATE_DEFAULT )
+        GTK_WIDGET_SET_FLAGS( widget, GTK_HAS_DEFAULT );
+    if ( !GTK_IS_TOGGLE_BUTTON(widget) && (nState & CTRL_STATE_FOCUSED) )
+        GTK_WIDGET_SET_FLAGS( widget, GTK_HAS_FOCUS );
+    if ( nState & CTRL_STATE_ENABLED )
+        GTK_WIDGET_SET_FLAGS( widget, GTK_SENSITIVE );
+    gtk_widget_set_state( widget, nGtkState );
 }
 
 /************************************************************************
@@ -3814,179 +3797,279 @@
 static void NWAddWidgetToCacheWindow( GtkWidget* widget, int nScreen )
 {
     NWFWidgetData& rData = gWidgetData[nScreen];
-	if ( !rData.gCacheWindow || !rData.gDumbContainer )
-	{
-		if ( !rData.gCacheWindow )
+    if ( !rData.gCacheWindow || !rData.gDumbContainer )
+    {
+        if ( !rData.gCacheWindow )
         {
-			rData.gCacheWindow = gtk_window_new( GTK_WINDOW_TOPLEVEL );
+            rData.gCacheWindow = gtk_window_new( GTK_WINDOW_TOPLEVEL );
             GdkScreen* pScreen = gdk_display_get_screen( gdk_display_get_default(), nScreen );
             if( pScreen )
                 gtk_window_set_screen( GTK_WINDOW(rData.gCacheWindow), pScreen );
         }
-		if ( !rData.gDumbContainer )
-			rData.gDumbContainer = gtk_fixed_new();
-		gtk_container_add( GTK_CONTAINER(rData.gCacheWindow), rData.gDumbContainer );
-		gtk_widget_realize( rData.gDumbContainer );
-		gtk_widget_realize( rData.gCacheWindow );
-	}
+        if ( !rData.gDumbContainer )
+            rData.gDumbContainer = gtk_fixed_new();
+        gtk_container_add( GTK_CONTAINER(rData.gCacheWindow), rData.gDumbContainer );
+        gtk_widget_realize( rData.gDumbContainer );
+        gtk_widget_realize( rData.gCacheWindow );
+    }
 
-	gtk_container_add( GTK_CONTAINER(rData.gDumbContainer), widget );
-	gtk_widget_realize( widget );
-	gtk_widget_ensure_style( widget );
+    gtk_container_add( GTK_CONTAINER(rData.gDumbContainer), widget );
+    gtk_widget_realize( widget );
+    gtk_widget_ensure_style( widget );
 
-	// Store widget's default flags
-	gWidgetDefaultFlags[ (long)widget ] = GTK_WIDGET_FLAGS( widget );
+    // Store widget's default flags
+    gWidgetDefaultFlags[ (long)widget ] = GTK_WIDGET_FLAGS( widget );
 }
 
 //-------------------------------------
 
 static void NWEnsureGTKButton( int nScreen )
 {
-	if ( !gWidgetData[nScreen].gBtnWidget )
-	{
-		gWidgetData[nScreen].gBtnWidget = gtk_button_new_with_label( "" );
-		NWAddWidgetToCacheWindow( gWidgetData[nScreen].gBtnWidget, nScreen );
-	}
+    if ( !gWidgetData[nScreen].gBtnWidget )
+    {
+        gWidgetData[nScreen].gBtnWidget = gtk_button_new_with_label( "" );
+        NWAddWidgetToCacheWindow( gWidgetData[nScreen].gBtnWidget, nScreen );
+    }
 }
 
 //-------------------------------------
 
 static void NWEnsureGTKRadio( int nScreen )
 {
-	if ( !gWidgetData[nScreen].gRadioWidget || !gWidgetData[nScreen].gRadioWidgetSibling )
-	{
-		gWidgetData[nScreen].gRadioWidget = gtk_radio_button_new( NULL );
-		gWidgetData[nScreen].gRadioWidgetSibling = gtk_radio_button_new_from_widget( GTK_RADIO_BUTTON(gWidgetData[nScreen].gRadioWidget) );
-		NWAddWidgetToCacheWindow( gWidgetData[nScreen].gRadioWidget, nScreen );
-		NWAddWidgetToCacheWindow( gWidgetData[nScreen].gRadioWidgetSibling, nScreen );
-	}
+    if ( !gWidgetData[nScreen].gRadioWidget || !gWidgetData[nScreen].gRadioWidgetSibling )
+    {
+        gWidgetData[nScreen].gRadioWidget = gtk_radio_button_new( NULL );
+        gWidgetData[nScreen].gRadioWidgetSibling = gtk_radio_button_new_from_widget( GTK_RADIO_BUTTON(gWidgetData[nScreen].gRadioWidget) );
+        NWAddWidgetToCacheWindow( gWidgetData[nScreen].gRadioWidget, nScreen );
+        NWAddWidgetToCacheWindow( gWidgetData[nScreen].gRadioWidgetSibling, nScreen );
+    }
 }
 
 //-------------------------------------
 
 static void NWEnsureGTKCheck( int nScreen )
 {
-	if ( !gWidgetData[nScreen].gCheckWidget )
-	{
-		gWidgetData[nScreen].gCheckWidget = gtk_check_button_new();
-		NWAddWidgetToCacheWindow( gWidgetData[nScreen].gCheckWidget, nScreen );
-	}
+    if ( !gWidgetData[nScreen].gCheckWidget )
+    {
+        gWidgetData[nScreen].gCheckWidget = gtk_check_button_new();
+        NWAddWidgetToCacheWindow( gWidgetData[nScreen].gCheckWidget, nScreen );
+    }
 }
 
 //-------------------------------------
 
 static void NWEnsureGTKScrollbars( int nScreen )
 {
-	if ( !gWidgetData[nScreen].gScrollHorizWidget )
-	{
-		gWidgetData[nScreen].gScrollHorizWidget = gtk_hscrollbar_new( NULL );
-		NWAddWidgetToCacheWindow( gWidgetData[nScreen].gScrollHorizWidget, nScreen );
-	}
+    if ( !gWidgetData[nScreen].gScrollHorizWidget )
+    {
+        gWidgetData[nScreen].gScrollHorizWidget = gtk_hscrollbar_new( NULL );
+        NWAddWidgetToCacheWindow( gWidgetData[nScreen].gScrollHorizWidget, nScreen );
+    }
 
-	if ( !gWidgetData[nScreen].gScrollVertWidget )
-	{
-		gWidgetData[nScreen].gScrollVertWidget = gtk_vscrollbar_new( NULL );
-		NWAddWidgetToCacheWindow( gWidgetData[nScreen].gScrollVertWidget, nScreen );
-	}
+    if ( !gWidgetData[nScreen].gScrollVertWidget )
+    {
+        gWidgetData[nScreen].gScrollVertWidget = gtk_vscrollbar_new( NULL );
+        NWAddWidgetToCacheWindow( gWidgetData[nScreen].gScrollVertWidget, nScreen );
+    }
 }
 
 //-------------------------------------
 
 static void NWEnsureGTKArrow( int nScreen )
 {
-	if ( !gWidgetData[nScreen].gArrowWidget || !gWidgetData[nScreen].gDropdownWidget )
-	{
-		gWidgetData[nScreen].gDropdownWidget = gtk_toggle_button_new();
-		NWAddWidgetToCacheWindow( gWidgetData[nScreen].gDropdownWidget, nScreen );
-		gWidgetData[nScreen].gArrowWidget = gtk_arrow_new( GTK_ARROW_DOWN, GTK_SHADOW_OUT );
-		gtk_container_add( GTK_CONTAINER(gWidgetData[nScreen].gDropdownWidget), gWidgetData[nScreen].gArrowWidget );
-		gtk_widget_set_rc_style( gWidgetData[nScreen].gArrowWidget );
-		gtk_widget_realize( gWidgetData[nScreen].gArrowWidget );
-	}
+    if ( !gWidgetData[nScreen].gArrowWidget || !gWidgetData[nScreen].gDropdownWidget )
+    {
+        gWidgetData[nScreen].gDropdownWidget = gtk_toggle_button_new();
+        NWAddWidgetToCacheWindow( gWidgetData[nScreen].gDropdownWidget, nScreen );
+        gWidgetData[nScreen].gArrowWidget = gtk_arrow_new( GTK_ARROW_DOWN, GTK_SHADOW_OUT );
+        gtk_container_add( GTK_CONTAINER(gWidgetData[nScreen].gDropdownWidget), gWidgetData[nScreen].gArrowWidget );
+        gtk_widget_set_style( gWidgetData[nScreen].gArrowWidget, NULL );
+        gtk_widget_realize( gWidgetData[nScreen].gArrowWidget );
+    }
 }
 
 //-------------------------------------
 
 static void NWEnsureGTKEditBox( int nScreen )
 {
-	if ( !gWidgetData[nScreen].gEditBoxWidget )
-	{
-		gWidgetData[nScreen].gEditBoxWidget = gtk_entry_new();
-		NWAddWidgetToCacheWindow( gWidgetData[nScreen].gEditBoxWidget, nScreen );
-	}
+    if ( !gWidgetData[nScreen].gEditBoxWidget )
+    {
+        gWidgetData[nScreen].gEditBoxWidget = gtk_entry_new();
+        NWAddWidgetToCacheWindow( gWidgetData[nScreen].gEditBoxWidget, nScreen );
+    }
 }
 
 //-------------------------------------
 
 static void NWEnsureGTKSpinButton( int nScreen )
 {
-	if ( !gWidgetData[nScreen].gSpinButtonWidget )
-	{
-		GtkAdjustment *adj = GTK_ADJUSTMENT( gtk_adjustment_new(0, 0, 1, 1, 1, 0) );
-		gWidgetData[nScreen].gSpinButtonWidget = gtk_spin_button_new( adj, 1, 2 );
+    if ( !gWidgetData[nScreen].gSpinButtonWidget )
+    {
+        GtkAdjustment *adj = GTK_ADJUSTMENT( gtk_adjustment_new(0, 0, 1, 1, 1, 0) );
+        gWidgetData[nScreen].gSpinButtonWidget = gtk_spin_button_new( adj, 1, 2 );
 
-		//Setting non-editable means it doesn't blink, so there's no timeouts
-		//running around to nobble us
-		gtk_editable_set_editable(GTK_EDITABLE(gWidgetData[nScreen].gSpinButtonWidget), false);
+        //Setting non-editable means it doesn't blink, so there's no timeouts
+        //running around to nobble us
+        gtk_editable_set_editable(GTK_EDITABLE(gWidgetData[nScreen].gSpinButtonWidget), false);
 
-		NWAddWidgetToCacheWindow( gWidgetData[nScreen].gSpinButtonWidget, nScreen );
-	}
+        NWAddWidgetToCacheWindow( gWidgetData[nScreen].gSpinButtonWidget, nScreen );
+    }
 }
 
 //-------------------------------------
 
 static void NWEnsureGTKNotebook( int nScreen )
 {
-	if ( !gWidgetData[nScreen].gNotebookWidget )
-	{
-		gWidgetData[nScreen].gNotebookWidget = gtk_notebook_new();
-		NWAddWidgetToCacheWindow( gWidgetData[nScreen].gNotebookWidget, nScreen );
-	}
+    if ( !gWidgetData[nScreen].gNotebookWidget )
+    {
+        gWidgetData[nScreen].gNotebookWidget = gtk_notebook_new();
+        NWAddWidgetToCacheWindow( gWidgetData[nScreen].gNotebookWidget, nScreen );
+    }
 }
 
 //-------------------------------------
 
-static void NWEnsureGTKOptionMenu( int nScreen )
+G_BEGIN_DECLS
+static void get_combo_box_entry_inner_widgets(GtkWidget *widget, gpointer client_data);
+static void get_combo_box_entry_arrow(GtkWidget *widget, gpointer client_data);
+static void get_combo_box_inner_widgets(GtkWidget *widget, gpointer client_data);
+G_END_DECLS
+
+static void get_combo_box_entry_inner_widgets(GtkWidget *widget, gpointer client_data)
+{
+    int nScreen = GPOINTER_TO_INT(client_data);
+    if (GTK_IS_TOGGLE_BUTTON(widget))
+        gWidgetData[nScreen].gComboBoxEntry_ButtonWidget = widget;
+    else if (GTK_IS_ENTRY(widget))
+    {
+        // #i59129# Setting non-editable means it doesn't blink, so
+        // there are no timeouts running around to nobble us
+        gtk_editable_set_editable(GTK_EDITABLE(widget), false);
+        gWidgetData[nScreen].gComboBoxEntry_EntryWidget = widget;
+    }
+    else
+        return;
+    gtk_widget_realize(widget);
+}
+
+static void get_combo_box_entry_arrow(GtkWidget *widget, gpointer client_data)
 {
-	if ( !gWidgetData[nScreen].gOptionMenuWidget )
-	{
-		gWidgetData[nScreen].gOptionMenuWidget = gtk_option_menu_new();
-		NWAddWidgetToCacheWindow( gWidgetData[nScreen].gOptionMenuWidget, nScreen );
-	}
+    if (GTK_IS_ARROW(widget))
+    {
+        int nScreen = GPOINTER_TO_INT(client_data);
+        gWidgetData[nScreen].gComboBoxEntry_ArrowWidget = widget;
+        gtk_widget_realize(widget);
+    }
 }
 
-//-------------------------------------
+static void NWEnsureGTKComboBoxEntry( int nScreen )
+{
+    if ( !gWidgetData[nScreen].gComboBoxEntryWidget )
+    {
+        gWidgetData[nScreen].gComboBoxEntryWidget = gtk_combo_box_entry_new();
+
+        NWAddWidgetToCacheWindow( gWidgetData[nScreen].gComboBoxEntryWidget, nScreen );
+
+        gtk_container_forall(GTK_CONTAINER(gWidgetData[nScreen].gComboBoxEntryWidget),
+            get_combo_box_entry_inner_widgets, GINT_TO_POINTER(nScreen) );
+
+        //If for some reason or other we couldn't find the expected children,
+        //alias them to some we know will definitely exist
+        if (!gWidgetData[nScreen].gComboBoxEntry_EntryWidget)
+        {
+            NWEnsureGTKEditBox( nScreen );
+            gWidgetData[nScreen].gComboBoxEntry_EntryWidget = gWidgetData[nScreen].gEditBoxWidget;
+        }
+        if (gWidgetData[nScreen].gComboBoxEntry_ButtonWidget)
+        {
+            //Dig around for the arrow
+            GtkWidget *child = GTK_BIN(gWidgetData[nScreen].gComboBoxEntry_ButtonWidget)->child;
+            if (GTK_IS_HBOX(child))
+            {
+                gtk_container_forall(GTK_CONTAINER(child), get_combo_box_entry_arrow,
+                    GINT_TO_POINTER(nScreen) );
+            }
+            else
+                get_combo_box_entry_arrow(child, GINT_TO_POINTER(nScreen));
+        }
+        else
+        {
+            NWEnsureGTKArrow( nScreen );
+            gWidgetData[nScreen].gComboBoxEntry_ButtonWidget = gWidgetData[nScreen].gDropdownWidget;
+        }
+        if (!gWidgetData[nScreen].gComboBoxEntry_ArrowWidget)
+        {
+            NWEnsureGTKArrow( nScreen );
+            gWidgetData[nScreen].gComboBoxEntry_ArrowWidget = gWidgetData[nScreen].gArrowWidget;
+        }
+    }
+}
 
-static void NWEnsureGTKCombo( int nScreen )
+static void get_combo_box_inner_widgets(GtkWidget *widget, gpointer client_data)
 {
-	if ( !gWidgetData[nScreen].gComboWidget )
-	{
-		gWidgetData[nScreen].gComboWidget = gtk_combo_new();
+    int nScreen = GPOINTER_TO_INT(client_data);
+    if (GTK_IS_TOGGLE_BUTTON(widget))
+        gWidgetData[nScreen].gComboBox_ButtonWidget = widget;
+    else if (GTK_IS_SEPARATOR(widget))
+        gWidgetData[nScreen].gComboBox_SeparatorWidget = widget;
+    else if (GTK_IS_ARROW(widget))
+        gWidgetData[nScreen].gComboBox_ArrowWidget = widget;
+    else
+        return;
+    gtk_widget_realize(widget);
+}
 
-		// #i59129# Setting non-editable means it doesn't blink, so
-        // there are no timeouts running around to nobble us
-		gtk_editable_set_editable(GTK_EDITABLE(GTK_COMBO(gWidgetData[nScreen].gComboWidget)->entry), false);
+static void NWEnsureGTKComboBox( int nScreen )
+{
+    if ( !gWidgetData[nScreen].gComboBoxWidget )
+    {
+        gWidgetData[nScreen].gComboBoxWidget = gtk_combo_box_new();
 
-		NWAddWidgetToCacheWindow( gWidgetData[nScreen].gComboWidget, nScreen );
-		// Must realize the ComboBox's children, since GTK
-		// does not do this for us in GtkCombo::gtk_widget_realize()
-		gtk_widget_realize( GTK_COMBO(gWidgetData[nScreen].gComboWidget)->button );
-		gtk_widget_realize( GTK_COMBO(gWidgetData[nScreen].gComboWidget)->entry );
-	}
+        NWAddWidgetToCacheWindow( gWidgetData[nScreen].gComboBoxWidget, nScreen );
+
+        gtk_container_forall(GTK_CONTAINER(gWidgetData[nScreen].gComboBoxWidget),
+            get_combo_box_inner_widgets, GINT_TO_POINTER(nScreen) );
+
+        //If for some reason or other we couldn't find the expected children,
+        //alias them to some we know will definitely exist
+        if (gWidgetData[nScreen].gComboBox_ButtonWidget)
+        {
+            //Dig around for the arrow
+            GtkWidget *child = GTK_BIN(gWidgetData[nScreen].gComboBox_ButtonWidget)->child;
+            if (GTK_IS_HBOX(child))
+            {
+                gtk_container_forall(GTK_CONTAINER(child), get_combo_box_inner_widgets,
+                    GINT_TO_POINTER(nScreen) );
+            }
+            else
+                get_combo_box_inner_widgets(child, GINT_TO_POINTER(nScreen));
+        }
+        else
+        {
+            NWEnsureGTKArrow( nScreen );
+            gWidgetData[nScreen].gComboBox_ButtonWidget = gWidgetData[nScreen].gDropdownWidget;
+        }
+
+        if (!gWidgetData[nScreen].gComboBox_ArrowWidget)
+        {
+            NWEnsureGTKArrow( nScreen );
+            gWidgetData[nScreen].gComboBox_ArrowWidget = gWidgetData[nScreen].gArrowWidget;
+        }
+    }
 }
 
 //-------------------------------------
 
 static void NWEnsureGTKScrolledWindow( int nScreen )
 {
-	if ( !gWidgetData[nScreen].gScrolledWindowWidget )
-	{
-		GtkAdjustment *hadj = GTK_ADJUSTMENT( gtk_adjustment_new(0, 0, 0, 0, 0, 0) );
-		GtkAdjustment *vadj = GTK_ADJUSTMENT( gtk_adjustment_new(0, 0, 0, 0, 0, 0) );
+    if ( !gWidgetData[nScreen].gScrolledWindowWidget )
+    {
+        GtkAdjustment *hadj = GTK_ADJUSTMENT( gtk_adjustment_new(0, 0, 0, 0, 0, 0) );
+        GtkAdjustment *vadj = GTK_ADJUSTMENT( gtk_adjustment_new(0, 0, 0, 0, 0, 0) );
 
-		gWidgetData[nScreen].gScrolledWindowWidget = gtk_scrolled_window_new( hadj, vadj );
-		NWAddWidgetToCacheWindow( gWidgetData[nScreen].gScrolledWindowWidget, nScreen );
-	}
+        gWidgetData[nScreen].gScrolledWindowWidget = gtk_scrolled_window_new( hadj, vadj );
+        NWAddWidgetToCacheWindow( gWidgetData[nScreen].gScrolledWindowWidget, nScreen );
+    }
 }
 
 //-------------------------------------
